const
     //pohyb smery sever, zapad, jih, vychod
     dx:array[0..3] of integer = (0, -1, 0, 1);
     dy:array[0..3] of integer = (-1, 0, 1, 0);

     MaxW = 500;
     MaxH = 500;
     MaxSeq = 500;

var
   {vstup}
   orders : array[1..MaxSeq] of char; {sekvence prikazu}
   orderslen : Integer; {pocet prikazu}
   map : array[1..MaxW, 1..MaxH] of boolean; {mapa}
   w, h : integer;    {rozmery planu}

   {pocet tahu do uteku}
   moves : array[1..MaxW, 1..MaxH, 0..3] of longint;
   {0 = nezkoumano, -1 = zkoumano ale zatim nic (resp. smycka),
    >0 = pocet tahu k uniku}

   {zasobnik prohledavani do hlubky}
   stackX, stackY : array[1..MaxW * MaxH * 4] of integer;
   stackDir : array[1..MaxW * MaxH * 4] of byte;
   stack : longint;

   leaving : longint; {pocet policek z nichz se unika}

   {pomocne promenne}
   i, j, k : integer;
   z: char;


function PositionOk(x, y : integer): boolean;
begin
 if (x > 0) and (y > 0) and (x <= w) and (y <= h) then
   PositionOk := map[x, y] else
   PositionOk := true;
end;

procedure Search;
var x, y, dir : longint;
   nx, ny, ndir, steps : longint;
   escapes : boolean;

 procedure SimMoves;
 var l : Integer;
 begin
   nx := x;
   ny := y;
   ndir := dir;
   escapes := false;
   for l := 1 to orderslen do
   begin
     case orders[l] of
     'L' : ndir := (ndir + 1)  mod 4;
     'R' : if ndir = 0 then ndir := 3
                       else ndir := (ndir - 1);
     '+' : if PositionOk(nx + dx[ndir], ny + dy[ndir]) then
            begin
              nx := nx + dx[ndir];
              ny := ny + dy[ndir];
            end;
     '-' : if PositionOk(nx - dx[ndir], ny - dy[ndir]) then
            begin
              nx := nx - dx[ndir];
              ny := ny - dy[ndir];
            end;
     end;
     if (nx < 1) or (ny < 1) or (nx > w) or (ny > h) then
      begin
        steps := l;
        escapes := true;
        exit;
      end;
   end;
   steps := orderslen;
 end;

begin
 while stack > 0 do
 begin
   x := stackX[stack];
   y := stackY[stack];
   dir := stackDir[stack];
   moves[x, y, dir] := -1;
   SimMoves;
   if escapes then {odsud primo uniknu}
   begin
     moves[x, y, dir] := steps;
     dec(stack);
   end else
   if moves[nx, ny, ndir] = -1 then {chytim se do smycky}
   begin
     dec(stack);
   end else
   if moves[nx, ny, ndir] > 0 then {nekam to vede}
   begin
     moves[x, y, dir] := steps + moves[nx, ny, ndir];
     dec(stack);
   end else { tj. moves[] = 0, takze musime prozkoumat }
   begin
     inc(stack);
     stackX[stack] := nx;
     stackY[stack] := ny;
     stackDir[stack] := ndir;
   end;
 end;
end;

begin
  close(input);
  assign(input, 'akce.in');
  reset(input);

 {* Nacteni vstupu *}
 readln(orderslen);
 for i := 1 to orderslen do
   begin
     read(z);
     orders[i] := z;
   end;
 readln(w, h);
 for j := 1 to h do
  begin
    for i := 1 to w do
    begin
      read(z);
      map[i, j] := (z = '.');
    end;
    readln;
  end;

 {prozkoumame vsechna policka ...}
 for i := 1 to w do
  for j := 1 to h do
  if map[i, j] then {... ktera neblokuje prekazka}
    if moves[i, j, 0] = 0 then {... a jeste jsme je nezkoumali}
    begin
      stack := 1;
      stackX[1] := i;
      stackY[1] := j;
      stackDir[1] := 0;
      Search;
    end;

  {napocitame policka z nichz se da uniknout}
  for i := 1 to w do
   for j := 1 to h do
    if moves[i, j, 0] > 0 then
     inc(leaving);

   close(output);
   assign(output, 'akce.out');
   rewrite(output);

  writeln(leaving);

  {vypiseme po radcich pocty kroku k uniku}
  for j := 1 to h do
  begin
    for i := 1 to w do
    begin
      if i > 1 then write(' ');
      if moves[i, j, 0] > 0 then
        write(moves[i, j, 0])
      else
        write(0);
    end;
    writeln;
  end;

 close(output);
end.
