#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#define MAXN 1000000

int isp, n;

int perm[MAXN];

void gperm()
{
  for (int i=0;  i<n; i++)
    perm[i] = i+1;

  int p, tmp;
  for (int i=1; i<n; i++) {
    p = rand() % (i+1);
    tmp = perm[p];
    perm[p] = perm[i];
    perm[i] = tmp;
  }
}

void gfunc()
{
  for (int i=0; i<n; i++) {
    perm[i] = (rand() % n) + 1;
  }
}

void gspec()
{
  int r[MAXN];

  int k = n/2;
  for (int i=0;  i<k-1; i++)
    r[i] = i+2;

  int p, tmp;
  int a = 0;
  for (int i=0; i<k-1; i++) {
    p = rand() % (k-i-1);
    perm[a] = r[p];
    a = r[p]-1;
  }

  for (int i=k+2;  i<n; i++)
    r[i] = i+1;

  a = k+1;
  for (int i=0; i<k-1; i++) {
    p = rand() % (k-i-1);
    perm[a] = r[p];
    a = r[p]-1;
  }
  perm[a] = (rand() % k) + 1;
}

int main()
{
  srand(time(0));

  scanf("%d %d", &isp, &n);

  if (isp==1)
    gperm();
  else if (isp==0)
    gfunc();
  else if (isp==2)
    gspec();
  else
    return 1;

  printf("%d\n", n);

  for (int i=0; i<n; i++)
    printf("%d\n", perm[i]);

  return 0;
}

